            #GIT_CMT=b8405ddf0d307d8ff22df3c173e727fc636262c5
            #GIT_CMT=0b75234df618b38187fff49e0a331ce6f6d7380c

%global __python_provides /usr/lib/rpm/pythondistdeps.py --provides --majorver-provides-versions 2.7,3.6,3.8,3.9

%global with_python3 0
%global with_python39 0
%global with_python311 0

%if 0%{?rhel} > 7
%global with_python39 1
%global with_python311 1
%endif


%global __python36 /usr/bin/python3.6
%global python36_pkgversion 3
%global python36_pkgversion2 3.6
%global python36_sitelib /usr/lib64/python3.6/site-packages

%global __python39 /usr/bin/python3.9
%global python39_pkgversion 39
%global python39_pkgversion2 3.9
%global python39_sitelib /usr/lib64/python3.9/site-packages

%global __python311 /usr/bin/python3.11
%global python311_pkgversion 3.11
%global python311_pkgversion2 3.11
%global python311_sitelib /usr/lib64/python3.11/site-packages

%global srcname oracledb

%define odpiver 5.2.0

Summary: Python interface to Oracle Database
Name: python-oracledb
Version:	2.4.0
Release: 1%{?dist}
#get from https://pypi.org/project/oracledb/#files
Source0: %{srcname}-%{version}.tar.bz2

Patch0: 0001-Hardcode-version-instead-of-calculating-it-on-the-fl.patch
License: Universal Permissive License (UPL) or Apache License 2.0
Group: Development/Libraries
Url: https://github.com/oracle/python-oracledb
AutoReq: 1

%description 
The python-oracledb driver is a Python programming language extension module 
allowing Python programs to connect to Oracle Database. 
The module conforms to the Python Database API 2.0 specification with 
a considerable number of additions and a couple of minor exclusions.

%if %{?with_python3}
%package -n python%{python36_pkgversion}-oracledb
Summary: Python3 interface to Oracle
BuildRequires: python%{python36_pkgversion}-devel
BuildRequires: python%{python36_pkgversion}-setuptools >= 53.0.0
BuildRequires: gcc
BuildRequires: python%{python3_pkgversion}-Cython >= 0.29.21

Requires:  python3 >= 3.6 
Requires:  python%{python36_pkgversion}-cryptography >= 3.2.1

Provides:  python%{python36_pkgversion}dist(:DBAPI:oracle) = 2.0

%description -n python%{python36_pkgversion}-oracledb
The python-oracledb driver is a Python programming language extension module 
allowing Python programs to connect to Oracle Database. 
The module conforms to the Python Database API 2.0 specification with 
a considerable number of additions and a couple of minor exclusions.
%endif

%if %{?with_python39}
%package -n python%{python39_pkgversion}-oracledb
Summary: Python3 interface to Oracle
BuildRequires: python%{python39_pkgversion}-devel
BuildRequires: python%{python39_pkgversion}-setuptools >= 53.0.0
BuildRequires: gcc
BuildRequires: python%{python3_pkgversion}-Cython >= 0.29.21

Requires:  python(abi) = 3.9
Requires:  python%{python39_pkgversion}-cryptography >= 3.2.1

Provides:  python%{python39_pkgversion2}dist(:DBAPI:oracle) = 2.0

%description -n python%{python39_pkgversion}-oracledb
The python-oracledb driver is a Python programming language extension module 
allowing Python programs to connect to Oracle Database. 
The module conforms to the Python Database API 2.0 specification with 
a considerable number of additions and a couple of minor exclusions.
%endif

%if %{?with_python311}
%package -n python%{python311_pkgversion}-oracledb
Summary: Python3 interface to Oracle
BuildRequires: python%{python311_pkgversion}-devel
BuildRequires: python%{python311_pkgversion}-setuptools >= 53.0.0
BuildRequires: gcc
BuildRequires: python%{python3_pkgversion}-Cython >= 0.29.21
BuildRequires: python%{python311_pkgversion}-pip


Requires:  python(abi) = 3.11
Requires:  python%{python311_pkgversion}-cryptography >= 3.2.1

Provides:  python%{python311_pkgversion}dist(:DBAPI:oracle) = 2.0

%description -n python%{python311_pkgversion}-oracledb
The python-oracledb driver is a Python programming language extension module 
allowing Python programs to connect to Oracle Database. 
The module conforms to the Python Database API 2.0 specification with 
a considerable number of additions and a couple of minor exclusions.
%endif


%prep 
%autosetup -p1 -n %{srcname}-%{version}

%build

%install
# needed for latest cython
export https_proxy=http://www-proxy-ash7.us.oracle.com
cd %{_builddir}/oracledb-%{version}
%if %{?with_python3}
%{__python36} setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES.36
%endif

%if %{?with_python39}
%{__python39} setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES.39
%endif

%if %{?with_python311}
%{__python311} setup.py install --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES.311
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{?with_python3}
%files -n python%{python36_pkgversion}-oracledb -f INSTALLED_FILES.36
%doc LICENSE.txt README.txt THIRD_PARTY_LICENSES.txt NOTICE.txt
%exclude %{python36_sitelib}/oracledb/__pycache__
%exclude %{python36_sitelib}/oracledb/oracledb-doc
%endif

%if %{?with_python39}
%files -n python%{python39_pkgversion}-oracledb -f INSTALLED_FILES.39
%doc LICENSE.txt README.txt THIRD_PARTY_LICENSES.txt NOTICE.txt
%exclude %{python39_sitelib}/oracledb/__pycache__
%exclude %{python39_sitelib}/oracledb/oracledb-doc
%endif

%if %{?with_python311}
%files -n python%{python311_pkgversion}-oracledb -f INSTALLED_FILES.311
%doc LICENSE.txt README.txt THIRD_PARTY_LICENSES.txt NOTICE.txt
%exclude %{python311_sitelib}/oracledb/__pycache__
%exclude %{python311_sitelib}/oracledb/oracledb-doc
%endif

%changelog
* Tue Aug 20 2024 EL Errata <el-errata_ww@oracle.com> 2.4.0-1
- Update to 2.4.0

* Mon Jul 29 2024 Alex Burmashev <alexander.burmashev@oracle.com> 2.3.0-1
- Update to 2.3.0
- Update setup.cfg to actually contain version
- Disabled python3.6 due to lack of support.

* Mon May 27 2024 EL Errata <el-errata_ww@oracle.com> 2.2.1-1
- Update to 2.2.1

* Mon May 06 2024 EL Errata <el-errata_ww@oracle.com> 2.2.0-1
- Update to 2.2.0

* Thu Apr 11 2024 EL Errata <el-errata_ww@oracle.com> 2.1.2-1
- Update to 2.1.2

* Thu Mar 21 2024 EL Errata <el-errata_ww@oracle.com> 2.1.1-1
- Update to 2.1.1

* Tue Mar 12 2024 EL Errata <el-errata_ww@oracle.com> 2.1.0-1
- Update to 2.1.0

* Tue Jan 09 2024 EL Errata <el-errata_ww@oracle.com> 2.0.1-1
- Update to 2.0.1

* Tue Dec 19 2023 EL Errata <el-errata_ww@oracle.com> 2.0.0-1
- Update to 2.0.0

* Mon Dec 18 2023 Alan Steinberg <alan.steinberg@oracle.com> 1.4.2-2
- Build for python3.9.

* Tue Oct 10 2023 EL Errata <el-errata_ww@oracle.com> 1.4.2-1
- Update to 1.4.2

* Wed Sep 06 2023 EL Errata <el-errata_ww@oracle.com> 1.4.1-1
- Update to 1.4.1 and ODPI to 5.0.0.

* Wed Aug 16 2023 EL Errata <el-errata_ww@oracle.com> 1.4.0-1
- Update to 1.4.0

* Thu Jun 15 2023 EL Errata <el-errata_ww@oracle.com> 1.3.2-1
- Update to 1.3.2

* Mon Apr 24 2023 EL Errata <el-errata_ww@oracle.com> 1.3.1-1
- Update to 1.3.1

* Fri Apr 07 2023 Alan Steinberg <alan.steinberg@oracle.com> 1.3.0-1
- Update to 1.3.0
- Updated odpi to v4.6.1

* Fri Jan 20 2023 Alan Steinberg <alan.steinberg@oracle.com> - 1.2.2-1
- Update to 1.2.2
- Updated odpi to v4.6.0

* Thu Jan 12 2023 EL Errata <el-errata_ww@oracle.com> 1.2.1-1
- Update to 1.2.1

* Mon Oct 17 2022 Qing Lin <qing.lin@oracle.com> - 1.1.1-1.el7
- update to 1.1.1

* Thu Sep 29 2022 Qing Lin <qing.lin@oracle.com> 1.1.1-1
- Update to v1.1.1
- lower the required version for cryptography

* Fri Jun 24 2022 Qing Lin <qing.lin@oracle.com> 1.0.1-1
- Update to v1.0.1
- Remove python2 and Update based on Christopher's comments [jirabug: OLDIS-18075]

* Fri Jun 3 2022 Qing Lin <qing.lin@oracle.com> 1.0.0-1.0.1
- Source renamed to python-oracledb
- Add BuildRequires for Cython
- Add Requires for cryptography 
